package es.us.lsi.daaw.servlets;

import java.io.IOException;
import java.util.Random;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletContext;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import es.us.lsi.daaw.beans.Cliente;
import es.us.lsi.daaw.beans.ListaErrores;

/**
 * Servlet implementation class for Servlet: Tratamiento
 *
 */
public class Tratamiento extends javax.servlet.http.HttpServlet implements javax.servlet.Servlet {
	
	/* (non-Java-doc)
	 * @see javax.servlet.http.HttpServlet#doGet(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException 
	{
		ServletContext aplicacion = getServletContext();
		HttpSession sesion = request.getSession();
		
		// Obtenemos el bean Cliente con los datos del formulario
		// Habra que comprobar que no es null
		Cliente cliente = (Cliente)sesion.getAttribute("cliente");
		
		// Obtenemos la lista de errores y la limpiamos
		// Habra que comprobar que no es null		
		ListaErrores errores = (ListaErrores)sesion.getAttribute("errores");
		errores.getMensajes().clear();

		// Actualizamos el bean Cliente
		// Habra que comprobar que los datos son vlidos
		cliente.setNombre( request.getParameter("nombre") );
		cliente.setApellidos( request.getParameter("apellidos") );

		// Validacin de los datos del formulario (simulacin)
		Random generador = (Random)aplicacion.getAttribute("generador");
		
		if ( generador == null ) {
			generador = new Random();
			aplicacion.setAttribute("generador", generador);
		}
		
		if ( generador.nextBoolean() ) {
			errores.getMensajes().add("Se han producido errores aleatorios");
		}
		
		// Ahora hacemos un forward hacia la pgina adecuada
		RequestDispatcher dispatcher = null;
		
		dispatcher = errores.getMensajes().isEmpty() ? 
					 getServletContext().getRequestDispatcher("/exito.jsp"):
				     getServletContext().getRequestDispatcher("/error.jsp");			
				
		if ( dispatcher != null )
			dispatcher.forward(request, response);
	}  	
	
	/* (non-Java-doc)
	 * @see javax.servlet.http.HttpServlet#doPost(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		doGet( request, response );
	}   	  	    
}